/* cmdvme
   use /dev/nbbqvio
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>

#include "nbbqvio.h"

#define TIMEOUT 0x20000
#define OPADDR   0x102e
#define HSADDR   0x1030
#define OPWOK    0x01
#define OPROK    0x02

int main(int argc, char *argv[]){
  unsigned long addr,lval,i,j;
  unsigned short sval,wval,ro=0,wo=0;
  int crate=1;

  if(argc < 4){
    printf("cmdvme c -[wr/lr/ww/lw/or/ow/on/qr/qw/qn] addr [val]\n");
    printf("cmdvme c -am val\n");
    exit(0);
  }else{
    init_nbbqvio();
    crate = argv[1][0]-'0';
    if(crate < 0 || 9 < crate)
      exit(0);
    
    printf("%s\n", argv[2]);
    if(strcmp(argv[2],"-wr") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = vme_read16_i(addr, crate);
      printf("%04x\n",sval);
    }else if(strcmp(argv[2],"-lr") == 0){
      addr = strtol(argv[3],NULL,0);
      lval = vme_read32_i(addr, crate);
      printf("%08lx\n",lval);
    }else if(strcmp(argv[2],"-ww") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      printf("!!");
      vme_write16_i(addr,sval, crate);
    }else if(strcmp(argv[2],"-lw") == 0){
      addr = strtol(argv[3],NULL,0);
      lval = strtol(argv[4],NULL,0);
      vme_write32_i(addr,lval, crate);
    }else if(strcmp(argv[2],"-am") == 0){
      lval = strtol(argv[3],NULL,0);
       printf("??");
     vme_amsr_i(lval, crate);
    }else if(strcmp(argv[2],"-qr") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[5],NULL,0);
      if(wval == 0 || wval > 8){
	wval = 1;
      }
      i=0;
      while(wo !=OPWOK && i<TIMEOUT){
	wo = vme_read16_i(addr+HSADDR, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+OPADDR,sval, crate);
	for(j=0;j<wval;j++){
	  i=0;
	  while(ro !=OPROK && i<TIMEOUT){
	    ro = vme_read16_i(addr+HSADDR, crate);
	    i++;
	  }
	  if(i<TIMEOUT){
	    usleep(10);
	    sval = vme_read16_i(addr+OPADDR, crate);
	    printf("%x\n",sval);
	  }else{
	    printf("Time out in read ok.\n");
	  }
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-qw") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[4],NULL,0);
      i=0;
      while(wo !=OPWOK && i<TIMEOUT){
	wo = vme_read16_i(addr+HSADDR, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+OPADDR,sval, crate);
	i=0;
	while(wo !=OPWOK && i<TIMEOUT){
	  wo = vme_read16_i(addr+HSADDR, crate);
	  i++;
	}
	if(i<TIMEOUT){
	  usleep(10);
	  vme_write16_i(addr+OPADDR,wval, crate);
	  printf("%x\n",sval);
	}else{
	  printf("Time out in write ok.\n");
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-qn") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      i=0;
      while(wo !=OPWOK && i<TIMEOUT){
	wo = vme_read16_i(addr+HSADDR, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+OPADDR,sval, crate);
      }else{
      printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-or") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[5],NULL,0);
      if(wval == 0 || wval > 8){
	wval = 1;
      }
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval, crate);
	for(j=0;j<wval;j++){
	  i=0;
	  while(ro !=0x01 && i<TIMEOUT){
	    ro = vme_read16_i(addr+0x50, crate);
	    i++;
	  }
	  if(i<TIMEOUT){
	    usleep(10);
	    sval = vme_read16_i(addr+0x52, crate);
	    printf("%x\n",sval);
	  }else{
	    printf("Time out in read ok.\n");
	  }
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-ow") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[5],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval, crate);
	i=0;
	while(wo !=0x02 && i<TIMEOUT){
	  wo = vme_read16_i(addr+0x50, crate);
	  i++;
	}
	if(i<TIMEOUT){
	  usleep(10);
	  vme_write16_i(addr+0x52,wval, crate);
	  printf("%x\n",sval);
	}else{
	  printf("Time out in write ok.\n");
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-on") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50, crate);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval, crate);
      }else{
      printf("Time out in write ok.\n");
    }
    }else{
      printf("cmdvme -[wr/lr/ww/lw/or/ow/qr/qw] addr [val]\n");
      printf("cmdvme -am val\n");
    }
    release_nbbqvio();
  }


  return 0;
}
