/* cmdvme
   use /dev/nbbqvio
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>

#include "nbbqvio-i.h"

/* #define DEBUG */

int nbbqvio_fd;
unsigned long nbbqvio_val[3];
unsigned short sval;

int init_nbbqvio_i(int dn){
  char dname[30];
  sprintf(dname,"/dev/nbbqvio%d",dn);
  if((nbbqvio_fd = open(dname,O_RDWR)) < 0){
    printf("Can't open %s\n",dname);
    return -1;
  }
  return 0;
}

int release_nbbqvio_i(void){
  if(nbbqvio_fd < 0){
    return -1;
  }else{
    close(nbbqvio_fd);
  }

  return 0;
}

unsigned short vme_read16_i(unsigned long addr,int dn){
  nbbqvio_val[0] = addr;
  nbbqvio_val[1] = dn;
  ioctl(nbbqvio_fd,NBBQVIO_READ16_I,nbbqvio_val);
  sval = nbbqvio_val[2] & 0x0000ffff;
  return sval;
}

unsigned long vme_read32_i(unsigned long addr,int dn){
  nbbqvio_val[0] = addr;
  nbbqvio_val[1] = dn;
  ioctl(nbbqvio_fd,NBBQVIO_READ32_I,nbbqvio_val);
  
  return nbbqvio_val[2];
}

int vme_read_i(unsigned long addr, unsigned short *val,int dn){
  *val = vme_read16_i(addr,dn);
  return 1;
}

int vme_write16_i(unsigned long addr, unsigned short val,int dn){
  nbbqvio_val[0] = addr;
  nbbqvio_val[1] = val & 0x0000ffff;
  nbbqvio_val[2] = dn;

  return ioctl(nbbqvio_fd,NBBQVIO_WRITE16_I,nbbqvio_val);
}

int vme_write32_i(unsigned long addr, unsigned long val,int dn){
  nbbqvio_val[0] = addr;
  nbbqvio_val[1] = val;
  nbbqvio_val[2] = dn;
  return ioctl(nbbqvio_fd,NBBQVIO_WRITE32_I,nbbqvio_val);
}

int vme_write_i(unsigned long addr, unsigned short *val,int dn){
  return vme_write16_i(addr,*val,dn);
}

int vme_amsr_i(unsigned long val, int dn){
  nbbqvio_val[0] = val;
  nbbqvio_val[1] = dn;
  return ioctl(nbbqvio_fd,NBBQVIO_AMSR_I,nbbqvio_val);
}
